# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ActivityMixin",
    ]

import pytz
import transaction

from datetime import datetime

from zope.component import getUtility

from lpresults.scripts.interfaces.activity import IActivitySet


UTC = pytz.timezone("UTC")


class ActivityMixin:

    def preProcess(self):
        """See Application."""
        super(ActivityMixin, self).preProcess()

        self.activity_started = datetime.now(tz=UTC)

    def postProcess(self, error):
        """See Application."""
        if not error:
            transaction.begin()
            self.activity_completed = datetime.now(tz=UTC)
            getUtility(IActivitySet).recordSuccess(
                self.name, self.activity_started, self.activity_completed)
            transaction.commit()

        super(ActivityMixin, self).postProcess(error)
