# Copyright 2010-2011 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

__metaclass__ = type

__all__ = [
    "ApplicationTestCase",
    "TestCase",
    "TestCaseWithFactory",
    ]

import codecs
import sys

from unittest import TestCase
from cStringIO import StringIO

from lpresults.database.testing import cases as database_cases

from lpresults.scripts.testing.factories import TestFactory


class ApplicationTestCase(TestCase):

    def setUp(self):
        # Trap stderr.
        self._real_stderr = sys.stderr
        sys.stderr = codecs.getwriter("utf8")(StringIO())

    def tearDown(self):
        sys.stderr = self._real_stderr


class TestCase(database_cases.DatabaseTestCase):

    pass


class TestCaseWithFactory(TestCase):

    factory_class = TestFactory

    def setUp(self):
        super(TestCaseWithFactory, self).setUp()

        self.factory = self.factory_class()
